/***************************************************************************
                          cron_impex.h  -  description
                             -------------------
    begin                : Sat Oct 28 2000
    copyright            : (C) 2000 by Dominique Laigle
    email                : lainal@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CRON_IMPEX_H
#define CRON_IMPEX_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/* Includes Unix */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <glib.h>

#ifndef STRUCT_HORAIRE
#define STRUCT_HORAIRE
typedef struct {
                 int heures;
                 int minutes;
               } horaire_t;
#endif

#ifndef STRUCT_BLOC_CYCLE
#define STRUCT_BLOC_CYCLE
typedef struct {
                 horaire_t heure_debut;
                 horaire_t heure_fin;
               } bloc_cycle_t;
#endif

#ifndef MAX_CYCLES
#define MAX_CYCLES 4
#endif

#ifndef MAX_GROUPES
#define MAX_GROUPES 4
#endif

#ifndef SCHEDULE_STRUTURES
#define SCHEDULE_STRUTURES
typedef struct {
                 bloc_cycle_t  day_cycles[MAX_GROUPES][MAX_CYCLES];
                 guint         nb_cycles[MAX_GROUPES];
               } day_program_t;

typedef struct {
                 GDate         date;
                 day_program_t day_program;
               } day_schedule_t;
#endif

/* Some constant definitions : part of the interface*/

#define CRON_IMPEX_OK                  0
#define CRON_IMPEX_ERR_ALLOC_MEM      -1
#define CRON_IMPEX_ERR_DATA_PH_1      -2
#define CRON_IMPEX_ERR_OPEN_FILE      -3
#define CRON_IMPEX_ERR_WRITE_FILE     -4
#define CRON_IMPEX_ERR_CYCLE_ALIASING -5
#define CRON_IMPEX_ERR_CYCLE_NO_END   -6
#define CRON_IMPEX_ERR_TOO_MUCH_CYCLE -7
#define CRON_IMPEX_ERR_CYCLE_DEF      -8

#define CRON_IMPEX_ON  1
#define CRON_IMPEX_OFF 0

#ifndef CRON_IMPEX_CRONTAB_FILE
#define CRON_IMPEX_CRONTAB_FILE "/tmp/gheather_crontab_file"
#endif

/* The interface is only the two functions of the library */

gint   cron_impex_export_crontab( day_schedule_t *, const gchar * );
gint   cron_impex_import_crontab( const gchar *, day_schedule_t * );
gchar *cron_impex_verbose_error_message( gint );

#endif  /* CRON_IMPEX_H */


