/***************************************************************************
                          groupadmin.h  -  description
                             -------------------
    begin                : Sat Apr 14 2001
    copyright            : (C) 2001 by Dominique Laigle
    email                : lainal@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
  Composite widget that groups the flags of the output state and the
  declaration and selection of activ group. This widget is highly
  specialized for the Gheather application, hence no name as "gtk_*" .
*/

#ifndef GROUPE_ADMIN_H
#define GROUPE_ADMIN_H

#include <gnome.h> /* for the GnomeDialog*/

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GROUPE_ADMIN(obj)          GTK_CHECK_CAST (obj, groupe_admin_get_type (), GroupeAdmin)
#define GROUPE_ADMIN_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, groupe_admin_get_type (), GroupeAdminClass)
#define IS_GROUPE_ADMIN(obj)       GTK_CHECK_TYPE (obj, groupe_admin_get_type ())

#ifndef DEFAULT_GROUP_1
#define DEFAULT_GROUP_1	0x03
#define DEFAULT_GROUP_2	0x0c
#define DEFAULT_GROUP_3	0x30
#define DEFAULT_GROUP_4	0xc0
#endif

#ifndef MAX_GROUPES
#define MAX_GROUPES 4
#endif

typedef struct _GroupeAdmin       GroupeAdmin;
typedef struct _GroupeAdminClass  GroupeAdminClass;

struct _GroupeAdmin
{
  GtkHBox   vbox;

  GtkWidget *group_state_flg,
            *group_button[4],
            *definition_btn,
            *definition_dialog; /* Argh ! */

  gint       activ_group; /* 0 ... 3 */
  guchar     group_definition_mask[MAX_GROUPES]; /* The mask related to the command char */
};

struct _GroupeAdminClass
{
  GtkHBoxClass parent_class;

  /* Default call-backs of the external signals. The first demands the
     parent appli to read again the current group beeing worked and
     the second ask the appli to notice that the group definition has
     changed (that will demand a new generation of cron table)
  */

  void (* new_group_select) (GroupeAdmin *the_groupe_admin);
  void (* new_group_defined) (GroupeAdmin *the_groupe_admin);

};

/* Public methods */

GtkType	   groupe_admin_get_type( void );
GtkWidget* groupe_admin_new( gboolean* );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* GROUPE_ADMIN_H */
