/***************************************************************************
                          gtkcalendrier.h  -  description
                             -------------------
    begin                : Mon Jan 1 2001
    copyright            : (C) 2001 by Dominique Laigle
    email                : lainal@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CALENDRIER_H
#define CALENDRIER_H

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_CALENDRIER(obj)		         ( GTK_CHECK_CAST ((obj), gtk_calendrier_get_type(), GtkCalendrier))
#define GTK_CALENDRIER_CLASS(klass)	   ( GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_CALENDRIER, GtkCalendrierClass))
#define GTK_IS_CALENDRIER(obj)		     ( GTK_CHECK_TYPE ( (obj), gtk_calendrier_get_type() ) )
#define GTK_IS_CALENDRIER_CLASS(klass) ( GTK_CHECK_CLASS_TYPE ((klass), gtk_calendrier_get_type()))

#define STRUCT_CLIPBOARD

 /* clipboard semantics */

enum {
       PAS_DEFINIE,
       JOURS_MOIS,
       JOURS_SEMAINE,
       LA_SEMAINE,
       LE_WEEK_END
     };

typedef struct {
                 GDate *dates_copy[31]; /* For copy-paste : 1 month large */
                 GDate *dates_paste[31];
                 gint   semantique;
                 gint   nb_jours_copy;
                 gint   nb_jours_paste;
               } clipb_t;


typedef struct _GtkCalendrier	      GtkCalendrier;
typedef struct _GtkCalendrierClass  GtkCalendrierClass;

struct _GtkCalendrier
{
  GtkWidget widget;

  GDate *date_interne,   /* Date currently displayed by the widget */
        *date_courante;  /* System date at the start-up of the widget */

  clipb_t clip_board;    /* For Copy-Paste operations */

  gchar jours_mois[42][3];
  gchar jours_semaine[7][4];
  gchar mois_annee[12][10];

  gint hauteur_texte;
};

struct _GtkCalendrierClass
{
  GtkWidgetClass parent_class;

  /* Call backs par dfaut */

  void (* new_date_copy)	    ( GtkCalendrier * );
  void (* new_date_paste)	    ( GtkCalendrier * );
  void (* new_date_selected)	( GtkCalendrier * );
};

/* Methods of the Interface */

GtkType	   gtk_calendrier_get_type(void);
GtkWidget* gtk_calendrier_new(void);

gint gtk_calendrier_get_clipboard_copy( GtkCalendrier *, GDate *[] );
gint gtk_calendrier_get_clipboard_paste( GtkCalendrier *, GDate *[] );
gint gtk_calendrier_get_clipboard_semantic( GtkCalendrier * );
gint gtk_calendrier_get_days_selected( GtkCalendrier *, guint [] );

gint gtk_calendrier_clear_clipboard( GtkCalendrier * );
gint gtk_calendrier_get_internal_date( GtkCalendrier *, GDate * );
gint gtk_calendrier_set_internal_date( GtkCalendrier *, GDate * );


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* CALENDRIER_H */
