/***************************************************************************
                          gtk_flag_binaire.h  -  description
                             -------------------
    begin                : Sun Jan 28 2001
    copyright            : (C) 2001 by Dominique Laigle
    email                : lainal@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FLAG_BINAIRE_H
#define FLAG_BINAIRE_H

#include <gdk/gdk.h>
#include <gtk/gtksignal.h>
#include <gtk/gtkwidget.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_FLAG_BINAIRE(obj)		         ( GTK_CHECK_CAST ((obj), gtk_flag_binaire_get_type(), GtkFlagBinaire))
#define GTK_FLAG_BINAIRE_CLASS(klass)	   ( GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_FLAG_BINAIRE, GtkFlagBinaireClass))
#define GTK_IS_FLAG_BINAIRE(obj)		     ( GTK_CHECK_TYPE ( (obj), gtk_flag_binaire_get_type() ) )
#define GTK_IS_FLAG_BINAIRE_CLASS(klass) ( GTK_CHECK_CLASS_TYPE ((klass), gtk_flag_binaire_get_type()))

#define MAX_FLAGS_ALLOWED 16 /* Mal gucken ob es reicht... */
#define LABEL_MAX_LENGTH  16 /* Da auch... */

#define STRUCT_FLAG
typedef struct {
                 gchar    *label;
                 gboolean flag;
               } flag_t;


typedef struct _GtkFlagBinaire	     GtkFlagBinaire;
typedef struct _GtkFlagBinaireClass  GtkFlagBinaireClass;

struct _GtkFlagBinaire
{
  GtkWidget widget;

  GdkColor  off_color,
            on_color;

  flag_t    *indicator;
  guint     nb_flags;
};

struct _GtkFlagBinaireClass
{
  GtkWidgetClass parent_class;
};

GtkType	   gtk_flag_binaire_get_type( void );
GtkWidget* gtk_flag_binaire_new( guint,gchar ** );

void gtk_flag_binaire_set_flag( GtkFlagBinaire *, guint );
void gtk_flag_binaire_clear_flag( GtkFlagBinaire *, guint );
void gtk_flag_binaire_set_label( GtkFlagBinaire *, guint, const gchar * );
void gtk_flag_binaire_set_on_color( GtkFlagBinaire *,const gchar * );
void gtk_flag_binaire_set_off_color( GtkFlagBinaire *,const gchar * );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FLAG_BINAIRE_H */
