/***************************************************************************
                          gtk_programmateur.h  -  description
                             -------------------
    begin                : Sun Jan 28 2001
    copyright            : (C) 2001 by Dominique Laigle
    email                : lainal@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PROGRAMMATEUR_H
#define PROGRAMMATEUR_H

#include <gdk/gdk.h>
#include <gtk/gtksignal.h>
#include <gtk/gtkwidget.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_PROGRAMMATEUR(obj)		         ( GTK_CHECK_CAST ((obj), gtk_programmateur_get_type(), GtkProgrammateur))
#define GTK_PROGRAMMATEUR_CLASS(klass)	   ( GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_PROGRAMMATEUR, GtkProgrammateurClass))
#define GTK_IS_PROGRAMMATEUR(obj)		     ( GTK_CHECK_TYPE ( (obj), gtk_programmateur_get_type() ) )
#define GTK_IS_PROGRAMMATEUR_CLASS(klass) ( GTK_CHECK_CLASS_TYPE ((klass), gtk_programmateur_get_type()))

#ifndef STRUCT_HORAIRE
#define STRUCT_HORAIRE
typedef struct {
                 int heures;
                 int minutes;
               } horaire_t;
#endif

#ifndef STRUCT_BLOC_CYCLE
#define STRUCT_BLOC_CYCLE
typedef struct {
                 horaire_t heure_debut;
                 horaire_t heure_fin;
               } bloc_cycle_t;
#endif

#define STRUCT_GEOMETRIE
typedef struct {
                 gint x_debut;
                 gint x_fin;
                 gint x_width;
               } geometrie_t;

#ifndef MAX_CYCLES
#define MAX_CYCLES 4 // Nbre maximum de cycles journaliers
#endif

#define NO_STATE     0
#define MOVE_STATE   1
#define RESIZE_STATE 2
/* Those ones got to be the highest values : they define that the timing
of a cycle has to be displayed */
#define LEFT_STATE   4
#define CENTER_STATE 8
#define RIGHT_STATE  16
#define PRESS_STATE  32

typedef struct _GtkProgrammateur	     GtkProgrammateur;
typedef struct _GtkProgrammateurClass  GtkProgrammateurClass;

struct _GtkProgrammateur
{
  GtkWidget widget;

  gint nb_cycles;

  bloc_cycle_t cycle[MAX_CYCLES];
};

struct _GtkProgrammateurClass
{
  GtkWidgetClass parent_class;

  /* Default signal Call back */

  void (* commit)	(GtkProgrammateur *programmateur);
};

GtkType	   gtk_programmateur_get_type( void );
GtkWidget* gtk_programmateur_new( void );

gint gtk_programmateur_add_cycle( GtkProgrammateur *, bloc_cycle_t );
gint gtk_programmateur_remove_cycle( GtkProgrammateur *);
gint gtk_programmateur_get_cycle( GtkProgrammateur *, guint, bloc_cycle_t * );
gint gtk_programmateur_get_nb_cycles( GtkProgrammateur * );
gint gtk_programmateur_reset_cycles( GtkProgrammateur * );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* PROGRAMMATEUR_H */
