/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : sam oct 28 22:20:55 CEST 2000
    copyright            : (C) 2000 by Dominique Laigle
    email                : lainal@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*** gheather */

#include <main.h>

int main(int argc, char* argv[])
{
  GtkWidget *appli_window, *main_container;
  GtkWidget *panel_container,
            *clavier_container;
  GtkWidget *quit_btn, *import_btn, *export_btn,
            *ejp_btn, *reset_btn, *status_btn;
  GtkWidget *calendrier, *programmateur, *groupeadmin;
  gboolean  groupe_defauts;
  GtkWidget *message_box;

  /* Imlibs inits are performed with gnome_init(), so we can't use only
     gtk_init() if we want to use the gnomeui widgets.
  */

  gnome_init( "Gheather","v0.1", argc, argv );

  appli_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

  main_container = gtk_hbox_new( FALSE, 2 );

  gtk_container_add( GTK_CONTAINER(appli_window), main_container);

  gtk_container_set_border_width( GTK_CONTAINER(main_container), 2 );

  gtk_window_set_title( GTK_WINDOW(appli_window), "gheather");

  gtk_window_set_policy( GTK_WINDOW(appli_window), TRUE, TRUE,TRUE );

  gtk_signal_connect( GTK_OBJECT(appli_window), "delete_event",
                      GTK_SIGNAL_FUNC(delete_event_cb),
                      NULL );

  /* Clavier container and its buttons */

  clavier_container = gtk_table_new( 2, 3, TRUE );
  gtk_container_set_border_width( GTK_CONTAINER(clavier_container), 0 );

  import_btn = gtk_button_new_with_label("Import");
  gtk_table_attach( GTK_TABLE(clavier_container), import_btn,
                    0, 1, 0, 1,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    0, 0
                   );

  export_btn = gtk_button_new_with_label("Export");
  gtk_table_attach( GTK_TABLE(clavier_container), export_btn,
                    1, 2, 0, 1,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    0, 0
                   );

  reset_btn = gtk_button_new_with_label("Reset");
  gtk_table_attach( GTK_TABLE(clavier_container), reset_btn,
                    2, 3, 0, 1,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    0, 0
                   );

  ejp_btn = gtk_button_new_with_label("IF Tests");
  gtk_table_attach( GTK_TABLE(clavier_container), ejp_btn,
                    0, 1, 1, 2,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    0, 0
                   );

  status_btn = gtk_button_new_with_label("Status");
  gtk_table_attach( GTK_TABLE(clavier_container), status_btn,
                    1, 2, 1, 2,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    0, 0
                   );

  quit_btn = gtk_button_new_with_label("Quit");
  gtk_table_attach( GTK_TABLE(clavier_container), quit_btn,
                    2, 3, 1, 2,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK,
                    0, 0
                   );

  /* Panel container and its subwidgets */

  panel_container = gtk_vbox_new( TRUE, 2 );
  gtk_container_set_border_width( GTK_CONTAINER(panel_container), 0 );

  groupeadmin = groupe_admin_new( &groupe_defauts ); /* becomes automatically a group admin */

  my_groupeadmin = groupeadmin;
  gtk_box_pack_start( GTK_BOX(panel_container), groupeadmin,
                      FALSE, TRUE, 1 );

  my_flagbinaire = GTK_FLAG_BINAIRE(my_groupeadmin->group_state_flg);

  programmateur = gtk_programmateur_new();
  my_programmateur = GTK_PROGRAMMATEUR(programmateur);
  gtk_box_pack_start( GTK_BOX(panel_container), programmateur,
                      FALSE, TRUE, 1 );

  gtk_box_pack_start( GTK_BOX(panel_container), clavier_container,
                      FALSE, TRUE, 1 );

  /* Main container filling */

  calendrier = gtk_calendrier_new();

  my_calendrier = GTK_CALENDRIER(calendrier);
  gtk_box_pack_start( GTK_BOX(main_container), calendrier,
                      TRUE, TRUE, 0 );

  gtk_box_pack_start( GTK_BOX(main_container), panel_container,
                      TRUE, TRUE, 0 );

  gtk_widget_show_all( appli_window );

  /* Small trick to force all the widgets to resize in order to
     really fullfil the allocated space. This trick is necessary
     since all the widgets have different size requests. */

  gdk_window_resize( appli_window->window,
                     appli_window->allocation.width + 1,                     appli_window->allocation.height + 1);

  /***********************************************************************/
  /*                Connections of Call-backs from widgets               */
  /***********************************************************************/

  gtk_signal_connect( GTK_OBJECT(import_btn), "clicked",
                      GTK_SIGNAL_FUNC(slot_import_btn_clicked),
                      NULL );

  gtk_signal_connect( GTK_OBJECT(export_btn), "clicked",
                      GTK_SIGNAL_FUNC(slot_export_btn_clicked),
                      NULL );

  gtk_signal_connect( GTK_OBJECT(ejp_btn), "clicked",
                      GTK_SIGNAL_FUNC(slot_ejp_btn_clicked),
                      NULL );

  gtk_signal_connect( GTK_OBJECT(reset_btn), "clicked",
                      GTK_SIGNAL_FUNC(slot_reset_btn_clicked),
                      NULL );

  gtk_signal_connect( GTK_OBJECT(status_btn), "clicked",
                      GTK_SIGNAL_FUNC(slot_status_btn_clicked),
                      NULL );

  /* This call back is also called by the timer every 5 sec. */

  gtk_timeout_add( 10000, ( GtkFunction ) slot_status_btn_clicked, NULL );

  gtk_signal_connect( GTK_OBJECT(quit_btn), "clicked",
                      GTK_SIGNAL_FUNC(delete_event_cb),
                      NULL );

  gtk_signal_connect( GTK_OBJECT(programmateur), "commit",
                      GTK_SIGNAL_FUNC(slot_programmateur_commit),
                      NULL );

  /* We don't need the signal "new_date_copy" of the calendrier */

  gtk_signal_connect( GTK_OBJECT(calendrier), "new_date_paste",
                      GTK_SIGNAL_FUNC(slot_calendrier_new_date_paste),
                      NULL );

  gtk_signal_connect( GTK_OBJECT(calendrier), "new_date_selected",
                      GTK_SIGNAL_FUNC(slot_calendrier_new_date_selected),
                      NULL );

  /* Connect to the same slot as the signal "new_date_selected" since
     the operations do perform are exactly the same when one just
     change the activ group */

  gtk_signal_connect( GTK_OBJECT(groupeadmin), "new_group_select",
                      GTK_SIGNAL_FUNC(slot_calendrier_new_date_selected),
                      NULL );

  gtk_signal_connect( GTK_OBJECT(groupeadmin), "new_group_defined",
                      GTK_SIGNAL_FUNC(slot_new_group_defined),
                      NULL );

  slot_import_btn_clicked(); /* crontab import at start-up */

  /* A modal dialog to says that we use the default group definitions */

  if ( groupe_defauts == TRUE )
    {
      message_box = gnome_message_box_new( _("Au moins une variable HEATHER_GP_n \n\
manque dans l'environnement, \nles valeurs par dfaut sont utilises"),
              GNOME_MESSAGE_BOX_WARNING, GNOME_STOCK_BUTTON_OK, NULL);

      gtk_window_set_modal( GTK_WINDOW(message_box), TRUE );
      gtk_widget_show( message_box );
    }

  gtk_main();

  return 0;
}

