/***************************************************************************
                          maincallbacks.h  -  description
                             -------------------
    begin                : Mon Apr 16 2001
    copyright            : (C) 2001 by Dominique Laigle
    email                : lainal@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MAIN_CALL_BACKS_H
#define MAIN_CALL_BACKS_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <stdio.h>
#include <gnome.h>

#include <gtkcalendrier.h>
#include <gtkprogrammateur.h>
#include <gtkflagbinaire.h>
#include <groupadmin.h>
#include <cron_impex.h>
#include <errno.h>

/* The main data structure is the whole schedule. We organize a day
   record as the cyles definition per group of commands. That means
   for one day, one can have different number of cycles regarding
   the groups concerned */

#ifndef STRUCT_HORAIRE
#define STRUCT_HORAIRE
typedef struct {
                 int heures;
                 int minutes;
               } horaire_t;
#endif

#ifndef STRUCT_BLOC_CYCLE
#define STRUCT_BLOC_CYCLE
typedef struct {
                 horaire_t heure_debut;
                 horaire_t heure_fin;
               } bloc_cycle_t;
#endif

#ifndef MAX_CYCLES
#define MAX_CYCLES 4 // Nbre maximum de cycles journaliers
#endif

#ifndef MAX_GROUPES
#define MAX_GROUPES 4 // Nbre maximum de cycles journaliers
#endif

#ifndef SCHEDULE_STRUTURES
#define SCHEDULE_STRUTURES
typedef struct {
                 bloc_cycle_t  day_cycles[MAX_GROUPES][MAX_CYCLES];
                 guint         nb_cycles[MAX_GROUPES];
               } day_program_t;

typedef struct {
                 GDate         date;
                 day_program_t day_program;
               } day_schedule_t;
#endif

#ifndef CRON_IMPEX_CRONTAB_FILE
#define CRON_IMPEX_CRONTAB_FILE "/tmp/gheather_crontab_file"
#endif

#ifndef STATUS_FILE
#define STATUS_FILE  "/tmp/gheather.status"
#endif
/* global variables of the main level*/

day_schedule_t   schedule[366];
GtkCalendrier    *my_calendrier;
GtkProgrammateur *my_programmateur;
GtkFlagBinaire   *my_flagbinaire;
GroupeAdmin      *my_groupeadmin;



/* global functions of the main level */

gint delete_event_cb( GtkWidget *, GdkEventAny *, gpointer );
void slot_import_btn_clicked( void );
void slot_export_btn_clicked( void );
void slot_ejp_btn_clicked( void );
void slot_reset_btn_clicked( void );
void slot_status_btn_clicked( void );
void slot_calendrier_new_date_paste( void );
void slot_calendrier_new_date_selected( void );
void slot_programmateur_commit( void );
void slot_new_group_defined( void );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* MAIN_CALL_BACKS_H */
